## openspecfun 0.3

=== Makefile ===
OPENLIBM_HOME=$(abspath .)
include ./Make.inc

SUBDIRS = amos Faddeeva

define INC_template
TEST=test
override CUR_SRCS = $(1)_SRCS
include $(1)/Make.files
SRCS += $$(addprefix $(1)/,$$($(1)_SRCS))
endef

DIR=test

$(foreach dir,$(SUBDIRS),$(eval $(call INC_template,$(dir))))

DUPLICATE_NAMES = $(filter $(patsubst %.S,%,$($(ARCH)_SRCS)),$(patsubst %.c,%,$(src_SRCS)))
DUPLICATE_SRCS = $(addsuffix .c,$(DUPLICATE_NAMES))

OBJS =  $(patsubst %.f,%.f.o,\
	$(patsubst %.S,%.S.o,\
	$(patsubst %.c,%.c.o,$(filter-out $(addprefix src/,$(DUPLICATE_SRCS)),$(SRCS)))))

all: libopenspecfun.a libopenspecfun.$(SHLIB_EXT) 
libopenspecfun.a: $(OBJS)
	$(AR) -rcs libopenspecfun.a $(OBJS)
libopenspecfun.$(SHLIB_EXT): $(OBJS)
ifeq ($(OS),WINNT)
	$(FC) -shared $(OBJS) $(LDFLAGS) -Wl,$(SONAME_FLAG),libopenspecfun.$(SHLIB_EXT) -o libopenspecfun.$(SHLIB_EXT)
else
	$(FC) -shared $(OBJS) $(LDFLAGS) -Wl,$(SONAME_FLAG),libopenspecfun.$(SHLIB_EXT).$(VERSION) -o libopenspecfun.$(SHLIB_EXT).$(VERSION)
	ln -s libopenspecfun.$(SHLIB_EXT).$(VERSION) libopenspecfun.$(SHLIB_EXT).$(word 1,$(VERSION_SPLIT)).$(word 2,$(VERSION_SPLIT))
	ln -s libopenspecfun.$(SHLIB_EXT).$(VERSION) libopenspecfun.$(SHLIB_EXT).$(word 1,$(VERSION_SPLIT))
	ln -s libopenspecfun.$(SHLIB_EXT).$(VERSION) libopenspecfun.$(SHLIB_EXT)
endif

install: all
	mkdir -p $(DESTDIR)$(shlibdir)
	mkdir -p $(DESTDIR)$(libdir)
	mkdir -p $(DESTDIR)$(includedir)
	cp -a libopenspecfun.$(SHLIB_EXT)* $(DESTDIR)$(shlibdir)/
	cp -a libopenspecfun.a $(DESTDIR)$(libdir)/
	cp -a Faddeeva/Faddeeva.h $(DESTDIR)$(includedir)

clean:
	@for dir in Faddeeva amos .; do \
		rm -fr $$dir/*.o $$dir/*.a $$dir/*.$(SHLIB_EXT)*; \
	done

distclean: clean

=== debian/changelog ===
openspecfun (0.3-2) unstable; urgency=medium

  * kfreebsd-and-hurd.patch: new patch, fixes FTBFS on kFreeBSD and Hurd.
  * Inject flags from dpkg-buildflags.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 02 Jul 2014 22:42:33 +0200

openspecfun (0.3-1) unstable; urgency=medium

  * Initial release. (Closes: #751379)

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 12 Jun 2014 14:47:09 +0200

=== debian/control ===
Source: openspecfun
Priority: optional
Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Build-Depends: debhelper (>= 9), gfortran, dh-exec
Standards-Version: 3.9.5
Section: libs
Homepage: https://github.com/JuliaLang/openspecfun
Vcs-Git: git://anonscm.debian.org/pkg-julia/openspecfun.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-julia/openspecfun.git

Package: libopenspecfun0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: collection of special mathematical functions (shared library)
 Openspecfun provides AMOS and Faddeeva.
 .
 AMOS (from Netlib) is a portable package for Bessel Functions of a Complex
 Argument and Nonnegative Order; it contains subroutines for computing Bessel
 functions and Airy functions.
 .
 Faddeeva allows computing the various error functions of arbitrary complex
 arguments (Faddeeva function, error function, complementary error function,
 scaled complementary error function, imaginary error function, and Dawson
 function); given these, one can also easily compute Voigt functions, Fresnel
 integrals, and similar related functions as well.

Package: libopenspecfun-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libopenspecfun0 (= ${binary:Version})
Description: collection of special mathematical functions (development files)
 Openspecfun provides AMOS and Faddeeva.
 .
 AMOS (from Netlib) is a portable package for Bessel Functions of a Complex
 Argument and Nonnegative Order; it contains subroutines for computing Bessel
 functions and Airy functions.
 .
 Faddeeva allows computing the various error functions of arbitrary complex
 arguments (Faddeeva function, error function, complementary error function,
 scaled complementary error function, imaginary error function, and Dawson
 function); given these, one can also easily compute Voigt functions, Fresnel
 integrals, and similar related functions as well.

## openspecfun 0.4

=== debian/changelog ===
openspecfun (0.4-1) unstable; urgency=medium

  * Imported Upstream version 0.4
  * debian/copyright: reflect upstream changes.
  * fix-soname.patch: remove, no longer needed.
  * Bump SONAME, shared lib now libopenspecfun1.
    The bump was not really needed, but we don't want to diverge from upstream.
  * Restrict archs to amd64 and i386.
    The rem_pio2 stuff does not compile elsewhere.
  * Improve package descriptions.

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 29 Jul 2014 14:07:59 +0200

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,8 @@
 Vcs-Git: git://anonscm.debian.org/pkg-julia/openspecfun.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-julia/openspecfun.git
 
-Package: libopenspecfun0
-Architecture: any
+Package: libopenspecfun1
+Architecture: amd64 i386
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -26,12 +26,14 @@
  scaled complementary error function, imaginary error function, and Dawson
  function); given these, one can also easily compute Voigt functions, Fresnel
  integrals, and similar related functions as well.
+ .
+ This package contains a shared version of the library.
 
 Package: libopenspecfun-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 i386
 Multi-Arch: same
-Depends: ${misc:Depends}, libopenspecfun0 (= ${binary:Version})
+Depends: ${misc:Depends}, libopenspecfun1 (= ${binary:Version})
 Description: collection of special mathematical functions (development files)
  Openspecfun provides AMOS and Faddeeva.
  .
@@ -44,3 +46,6 @@
  scaled complementary error function, imaginary error function, and Dawson
  function); given these, one can also easily compute Voigt functions, Fresnel
  integrals, and similar related functions as well.
+ .
+ This package contains the development files needed to compile software using
+ openspecfun.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ 

override_dh_auto_build:
	make CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS)" FFLAGS="$(FFLAGS)"

## openspecfun 0.5.0

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 OPENLIBM_HOME=$(abspath .)
 include ./Make.inc
 
-SUBDIRS = amos Faddeeva
+SUBDIRS = amos Faddeeva rem_pio2
 
 define INC_template
 TEST=test
@@ -28,10 +28,9 @@
 ifeq ($(OS),WINNT)
 	$(FC) -shared $(OBJS) $(LDFLAGS) -Wl,$(SONAME_FLAG),libopenspecfun.$(SHLIB_EXT) -o libopenspecfun.$(SHLIB_EXT)
 else
-	$(FC) -shared $(OBJS) $(LDFLAGS) -Wl,$(SONAME_FLAG),libopenspecfun.$(SHLIB_EXT).$(VERSION) -o libopenspecfun.$(SHLIB_EXT).$(VERSION)
-	ln -s libopenspecfun.$(SHLIB_EXT).$(VERSION) libopenspecfun.$(SHLIB_EXT).$(word 1,$(VERSION_SPLIT)).$(word 2,$(VERSION_SPLIT))
-	ln -s libopenspecfun.$(SHLIB_EXT).$(VERSION) libopenspecfun.$(SHLIB_EXT).$(word 1,$(VERSION_SPLIT))
-	ln -s libopenspecfun.$(SHLIB_EXT).$(VERSION) libopenspecfun.$(SHLIB_EXT)
+	$(FC) -shared $(OBJS) $(LDFLAGS) -Wl,$(SONAME_FLAG),libopenspecfun.$(SHLIB_EXT).$(SOMAJOR) -o libopenspecfun.$(SHLIB_EXT).$(SOMAJOR).$(SOMINOR)
+	ln -sf libopenspecfun.$(SHLIB_EXT).$(SOMAJOR).$(SOMINOR) libopenspecfun.$(SHLIB_EXT).$(SOMAJOR)
+	ln -sf libopenspecfun.$(SHLIB_EXT).$(SOMAJOR).$(SOMINOR) libopenspecfun.$(SHLIB_EXT)
 endif
 
 install: all
@@ -43,7 +42,7 @@
 	cp -a Faddeeva/Faddeeva.h $(DESTDIR)$(includedir)
 
 clean:
-	@for dir in Faddeeva amos .; do \
+	@for dir in $(SUBDIRS) .; do \
 		rm -fr $$dir/*.o $$dir/*.a $$dir/*.$(SHLIB_EXT)*; \
 	done

=== debian/changelog ===
openspecfun (0.5.0-1) unstable; urgency=medium

  [ Sébastien Villemot ]
  * Remove Sébastien Villemot from Uploaders.

  [ Graham Inggs ]
  * New upstream release.
  * Drop kfreebsd-hurd.patch included upstream.
  * Update debian/copyright.
  * Use secure URIs for VCS fields.
  * Bump Standards-Version to 3.9.7, no further changes.

 -- Graham Inggs <ginggs@debian.org>  Tue, 29 Mar 2016 17:38:55 +0200

openspecfun (0.4-3) unstable; urgency=medium

  * Build on GNU/kFreeBSD and GNU/Hurd.

 -- Graham Inggs <ginggs@debian.org>  Tue, 27 Oct 2015 11:06:03 +0200

openspecfun (0.4-2) unstable; urgency=medium

  * Add myself to uploaders.
  * Build everywhere. (Closes: #799036)
  * Bump Standards-Version to 3.9.6, no changes.

 -- Graham Inggs <ginggs@debian.org>  Mon, 26 Oct 2015 04:56:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,16 @@
 Source: openspecfun
 Priority: optional
 Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
-Uploaders: Sébastien Villemot <sebastien@debian.org>
-Build-Depends: debhelper (>= 9), gfortran, dh-exec
-Standards-Version: 3.9.5
+Uploaders: Graham Inggs <ginggs@debian.org>
+Build-Depends: debhelper (>= 9), dh-exec, gfortran
+Standards-Version: 3.9.7
 Section: libs
 Homepage: https://github.com/JuliaLang/openspecfun
-Vcs-Git: git://anonscm.debian.org/pkg-julia/openspecfun.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-julia/openspecfun.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-julia/openspecfun.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-julia/openspecfun.git
 
 Package: libopenspecfun1
-Architecture: amd64 i386
+Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -31,9 +31,9 @@
 
 Package: libopenspecfun-dev
 Section: libdevel
-Architecture: amd64 i386
+Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libopenspecfun1 (= ${binary:Version})
+Depends: libopenspecfun1 (= ${binary:Version}), ${misc:Depends}
 Description: collection of special mathematical functions (development files)
  Openspecfun provides AMOS and Faddeeva.
  .

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/openspecfun-$1\.tar\.gz/ \
  https://github.com/JuliaLang/openspecfun/tags .*/v?(\d\S*)\.tar\.gz

## openspecfun 0.5.3

=== Makefile ===
OPENLIBM_HOME=$(abspath .)
include ./Make.inc

SUBDIRS = amos Faddeeva rem_pio2

define INC_template
TEST=test
override CUR_SRCS = $(1)_SRCS
include $(1)/Make.files
SRCS += $$(addprefix $(1)/,$$($(1)_SRCS))
endef

DIR=test

$(foreach dir,$(SUBDIRS),$(eval $(call INC_template,$(dir))))

DUPLICATE_NAMES = $(filter $(patsubst %.S,%,$($(ARCH)_SRCS)),$(patsubst %.c,%,$(src_SRCS)))
DUPLICATE_SRCS = $(addsuffix .c,$(DUPLICATE_NAMES))

OBJS =  $(patsubst %.f,%.f.o,\
	$(patsubst %.S,%.S.o,\
	$(patsubst %.c,%.c.o,$(filter-out $(addprefix src/,$(DUPLICATE_SRCS)),$(SRCS)))))

# If we're on windows, don't do versioned shared libraries.  If we're on OSX,
# put the version number before the .dylib.  Otherwise, put it after.
ifeq ($(OS), WINNT)
OSF_MAJOR_MINOR_SHLIB_EXT := $(SHLIB_EXT)
else
ifeq ($(OS), Darwin)
OSF_MAJOR_MINOR_SHLIB_EXT := $(SOMAJOR).$(SOMINOR).$(SHLIB_EXT)
OSF_MAJOR_SHLIB_EXT := $(SOMAJOR).$(SHLIB_EXT)
else
OSF_MAJOR_MINOR_SHLIB_EXT := $(SHLIB_EXT).$(SOMAJOR).$(SOMINOR)
OSF_MAJOR_SHLIB_EXT := $(SHLIB_EXT).$(SOMAJOR)
endif
endif

all: libopenspecfun.a libopenspecfun.$(OSF_MAJOR_MINOR_SHLIB_EXT)
libopenspecfun.a: $(OBJS)
	$(AR) -rcs libopenspecfun.a $(OBJS)
libopenspecfun.$(OSF_MAJOR_MINOR_SHLIB_EXT): $(OBJS)
	$(FC) -shared $(OBJS) $(LDFLAGS) $(LDFLAGS_add) -Wl,$(SONAME_FLAG),libopenspecfun.$(OSF_MAJOR_SHLIB_EXT) -o $@
ifneq ($(OS),WINNT)
	ln -sf $@ libopenspecfun.$(OSF_MAJOR_SHLIB_EXT)
	ln -sf $@ libopenspecfun.$(SHLIB_EXT)
endif

install: all
	mkdir -p $(DESTDIR)$(shlibdir)
	mkdir -p $(DESTDIR)$(libdir)
	mkdir -p $(DESTDIR)$(includedir)
	cp -a libopenspecfun.*$(SHLIB_EXT)* $(DESTDIR)$(shlibdir)/
	cp -a libopenspecfun.a $(DESTDIR)$(libdir)/
	cp -a Faddeeva/Faddeeva.h $(DESTDIR)$(includedir)

clean:
	@for dir in $(SUBDIRS) .; do \
		rm -fr $$dir/*.o $$dir/*.a $$dir/*.$(SHLIB_EXT)*; \
	done

distclean: clean

=== debian/changelog ===
openspecfun (0.5.3-4) unstable; urgency=medium

  [ Peter Colberg ]
  * Update Vcs-* fields for move to salsa.debian.org

  [ Mo Zhou ]
  * Add myself to maintainers.
  * Bump debhelper compat level to 11 .
    - Remove --parallel option from rules.
  * Upstream moved from JuliaLang to JuliaMath:
    * Upgrade watch file to version 4. And Update upstream URL.
    * Update upstream Homepage URL.
  * Bump Standards-Version to 4.1.4 .
    * Change copyright-format URL into https form. (3.9.8 -> 4.0.0)
  * Add autopkgtest control file, along with two Faddeeva tests.
  * Override dh_auto_test and run the Faddeeva tests.
    + Add debian/clean: Removes the test binaries.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 30 Jun 2018 14:55:46 +0000

openspecfun (0.5.3-3) unstable; urgency=medium

  * Use openlibm instead of libm on mips, mips64el and mipsel

 -- Graham Inggs <ginggs@debian.org>  Tue, 24 Jan 2017 20:56:25 +0200

openspecfun (0.5.3-2) unstable; urgency=medium

  * Use openlibm instead of libm on armhf and ppc64
  * Update debian/copyright

 -- Graham Inggs <ginggs@debian.org>  Sat, 21 Jan 2017 22:48:40 +0200

openspecfun (0.5.3-1) unstable; urgency=medium

  * New upstream release
  * Add debian/gbp.conf for pristine-tar

 -- Peter Colberg <peter@colberg.org>  Sat, 30 Jul 2016 23:18:56 -0400

openspecfun (0.5.2-1) unstable; urgency=medium

  [ Peter Colberg ]
  * New upstream release
  * Update debian/copyright
  * Enable parallel build
  * Enable bindnow hardening flag
  * Use libopenlibm on architectures that have it
  * Link with -Wl,--as-needed to avoid useless library dependencies
  * Bump Standards-Version to 3.9.8, no further changes
  * Add myself to Uploaders

  [ Graham Inggs ]
  * Use openlibm instead of libm on arm64

 -- Peter Colberg <peter@colberg.org>  Thu, 23 Jun 2016 08:22:44 -0400

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,18 @@
 Source: openspecfun
 Priority: optional
 Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
-Uploaders: Graham Inggs <ginggs@debian.org>
-Build-Depends: debhelper (>= 9), dh-exec, gfortran
-Standards-Version: 3.9.7
+Uploaders: Graham Inggs <ginggs@debian.org>,
+           Peter Colberg <peter@colberg.org>,
+           Mo Zhou <cdluminate@gmail.com>,
+Build-Depends: debhelper (>= 11),
+               dh-exec,
+               gfortran,
+               libopenlibm-dev [any-i386 any-amd64 arm64 armhf mips mips64el mipsel powerpc ppc64 ppc64el]
+Standards-Version: 4.1.4
 Section: libs
-Homepage: https://github.com/JuliaLang/openspecfun
-Vcs-Git: https://anonscm.debian.org/git/pkg-julia/openspecfun.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-julia/openspecfun.git
+Homepage: https://github.com/JuliaMath/openspecfun
+Vcs-Git: https://salsa.debian.org/julia-team/openspecfun.git
+Vcs-Browser: https://salsa.debian.org/julia-team/openspecfun
 
 Package: libopenspecfun1
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

# Use libopenlibm on architectures that have it
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386 arm64 armhf mips mips64el mipsel powerpc ppc64 ppc64el hurd-i386 kfreebsd-amd64 kfreebsd-i386 x32))
BUILD_FLAGS += USE_OPENLIBM=1
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

# Avoid useless library dependencies
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- prefix=/usr CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS)" FFLAGS="$(FFLAGS)" $(BUILD_FLAGS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e; $(CC) Faddeeva/Faddeeva.c -DTEST_FADDEEVA -lm -o test-faddeeva-syslibm; ./test-faddeeva-syslibm
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386 arm64 armhf mips mips64el mipsel powerpc ppc64 ppc64el hurd-i386 kfreebsd-amd64 kfreebsd-i386 x32))
	set -e; $(CC) Faddeeva/Faddeeva.c -DTEST_FADDEEVA -lopenlibm -o test-faddeeva-openlibm; ./test-faddeeva-openlibm
endif
endif

=== debian/tests/control ===
# NOTE
# 1. G++ would fail to compile the test binaries because the *.hh header is missing.

Test-Command: gcc Faddeeva/Faddeeva.c -DTEST_FADDEEVA -lm -o test-faddeeva-syslibm; ./test-faddeeva-syslibm
Depends: @, build-essential

Test-Command: gcc Faddeeva/Faddeeva.c -DTEST_FADDEEVA -lopenlibm -o test-faddeeva-openlibm; ./test-faddeeva-openlibm
Depends: @, build-essential, libopenlibm-dev

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%openspecfun-$1.tar.gz%" \
    https://github.com/JuliaMath/openspecfun/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
